//************************************************************************
//                                                                         
//        Qn_̈ܓxoxʂ߂vO 
//
//      Ver. 2.0    2021/02/11          By   takesako@mrj.biglobe.ne.jp    
//                                           (c) Shinobu Takesako          
//
//@ڍׂVincenty@̏ڍׂ(https://ja.wikipedia.org/wiki/Vincenty%E6%B3%95)Q
//
//ŗ
//ver. 1.0 2021/02/11 [X 
//ver. 2.0 2021/02/12 xʌvZǉ 
//*************************************************************************

#include <stdio.h>
#include <math.h>

#define pai (3.1415926535897932/180.0)
#define pi  (3.1415926535897932)

//************************************************************************
// Qn_̈ܓxoxʂ߂vO (ȈՌvZ)
// lat1:쑤ܓx@lon1;쑤ox lat2:kܓx@lon2;kox
// dirc:^k̕(x,{΁|) dist:n_ԋ(m)
//************************************************************************

void Direction (double lon1, double lat1, double lon2, double lat2, double *dirc, double *dist)
{
	double dlon,ddi,ddk,W,M,N,mphi,dphi,Rx,E2;

	Rx = 6378137.0;//ԓa(m)
	E2 = 6.69437999019758E-03;//2S(e^2)

	dphi = lat2 - lat1;
	dlon = lon2 - lon1;
	mphi = (lat1 + lat2) / 2.0;

	W = sqrt(1 - E2 * sin(mphi * pai )  * sin(mphi * pai ));
	M = Rx * (1 - E2) / (W*W*W);
	N = Rx / W;

	ddi = dphi * pai * M;
	ddk = dlon * pai * N * cos(mphi * pai);

	//2n_Ԃ̋
	*dist = sqrt((dphi * pai * M) * (dphi * pai * M) + (dlon * pai* N * cos(mphi * pai))* (dlon * pai* N * cos(mphi * pai)));
	// lat1/lon1猩
	*dirc = (atan2(ddi, ddk) /pai -90.0 );
}

//************************************************************************
// Qn_̈ܓxoxʂ߂vO (xvZ)
// lat1:쑤ܓx@lon1;쑤ox lat2:kܓx@lon2;kox
// dirc:^k̕(x,{΁|) dist:n_ԋ(m)
//************************************************************************

void VincentyInverse(double lon1,double lat1, double lon2 ,double lat2,double *dirc, double *dist)
{
	double r,f,rs,cosU1, U1,U2,sinU1,cosU2,sinU2,u2,omega,A,B,C;
	double lamda,sinlamda,coslamda,dlamda,sinalpha,cos2alpha;
	double sigma,sinsigma,cossigma,sin2sigma,cos2sigmam,dsigma,dirc2;
	int count;
 
//	r = 6378137.0;//[GRS80]a
//  f = 1/298.257222101;//[GRS80]a

    r=    6378137.0; // [WGS84]a
    f=    1 / 298.257223563;// [WGS84]G
	rs = r * (1 - f);  

    lat1 = lat1*pai;
    lat2 = lat2*pai;
    lon1 = lon1*pai;
    lon2 = lon2*pai;

    U1 = atan((1 - f) * tan(lat1));
    U2 = atan((1 - f) * tan(lat2));
    sinU1 = sin(U1);
    sinU2 = sin(U2);
    cosU1 = cos(U1);
    cosU2 = cos(U2);

	omega = lon2 - lon1;

	lamda = omega;
    count = 0;

	while(1){
		sinlamda = sin(lamda);
		coslamda = cos(lamda);
        sin2sigma = pow(cosU2 * sinlamda, 2.0) + pow(cosU1 * sinU2 - sinU1 * cosU2 * coslamda, 2.0);
		sinsigma = sqrt(sin2sigma);
        cossigma = sinU1 * sinU2 + cosU1 * cosU2 * coslamda;
        sigma = atan2(sinsigma, cossigma);
        sinalpha = cosU1 * cosU2 * sinlamda / sinsigma;
        cos2alpha = 1 - pow(sinalpha,2.0);
        cos2sigmam = cossigma - 2.0 * sinU1 * sinU2 / cos2alpha;
        C = f / 16.0 * cos2alpha * (4.0 + f * (4.0 - 3.0 * cos2alpha));
        dlamda = lamda;
        lamda = omega + (1 - C) * f * sinalpha * (sigma + C * sinsigma * (cos2sigmam + C * cossigma * (-1 + 2 * cos2sigmam * cos2sigmam)));
        if( fabs(lamda - dlamda) <= 1e-12)  break;
		if (count++>10 ) break;
 }

    u2 = cos2alpha * (r *r - rs *rs) / (rs *rs);
    A = 1 + u2 / 16384.0 * (4096.0 + u2 * (-768.0 + u2 * (320.0 - 175.0 * u2)));
    B = u2 / 1024.0 * (256.0 + u2 * (-128.0 + u2 * (74.0 - 47.0 * u2)));
    dsigma = B * sinsigma * (cos2sigmam + B / 4 * (cossigma * (-1 + 2 * cos2sigmam *cos2sigmam) 
		- B / 6 * cos2sigmam * (-3 + 4 * sinsigma *sinsigma) * (-3 + 4 * cos2sigmam *cos2sigmam)));

	//2n_Ԃ̋
	*dist = rs * A * (sigma - dsigma);
	// lat1/lon1猩
	*dirc = -atan2(cosU2 * sinlamda, cosU1 * sinU2 - sinU1 * cosU2 * coslamda)/pai;
	// lat2/lon2猩
	dirc2 = (atan2(cosU1 * sinlamda, -sinU1 * cosU2 + cosU1 * sinU2 * coslamda) +pi)/pai;

}


//************************************************************************
// n_1(ܓxox)̕(dirc)Ƌ(dist)Œn_2(ܓxox)߂vO 
// lat1:ܓx@lon1;ox lat2:ܓx@lon2;ox
// dirc:^k̕(xC{΁C|) dist:n_ԋ(m)
//************************************************************************

vincenty(double lat1, double lon1,double dirc,double dist,double *lat2, double *lon2)
{

	double r,rs,f,u1,sigma1,alpha,u2,A,B,sigma,sigma0,dm,x,dSigma,y,lamda,C,z,omega;

	lat1=lat1*pai;
	lon1=lon1*pai;
	dirc=-dirc*pai;

//	r = 6378137.0;//[GRS80]a
//  f = 1/298.257222101;//[GRS80]a

	r=    6378137.0;         // [WGS84]a
    f=    1 / 298.257223563;// [WGS84]G
	rs = r * (1 -f);  
	
	u1 = atan((1 - f) * tan(lat1));
	sigma1 = atan2( tan(u1) , cos(dirc) );

	alpha = asin( cos(u1) * sin(dirc) );
	u2 =  pow( cos(alpha),2.0) * (pow(r,2.0) -pow(rs,2.0)) / pow(rs,2);
	A = 1 + (u2/16384.0)*(4096.0 + u2 * (-768.0 + u2 * (320.0 - 175.0 * u2)));
	B = (u2 / 1024.0) * (256.0 + u2 * (-128.0 + u2 * (74.0 - 47.0 * u2)));
	sigma = dist / rs / A;

	while(1){
	sigma0 = sigma;
	dm = 2.0 * sigma1 + sigma;
	x = cos(sigma) * ( -1.0 + 2.0 * pow(cos(dm),2.0) ) - B / 6.0 * cos(dm) * ( -3.0 + 4.0 * pow(sin(dm),2.0)) * ( -3.0 + 4.0 * pow(cos(dm),2.0));
    dSigma = B * sin(sigma) * ( cos(dm) + B / 4.0 * x);
	sigma = dist / rs / A + dSigma;
	if( fabs(sigma0 - sigma)<1e-14 ) break;
	} 
 
	
	x = sin(u1) * cos(sigma) + cos(u1) * sin(sigma) * cos(dirc);
	y = (1 - f) * pow( pow( sin(alpha),2.0) + pow( sin(u1) * sin(sigma) - cos(u1) * cos(sigma) * cos(dirc) ,2.0) , 0.5);
	lamda = atan2(sin(sigma) * sin(dirc) , (cos(u1) * cos(sigma) - sin(u1) * sin(sigma) * cos(dirc)));
	C = (f / 16.0) * pow(cos(alpha),2.0) * (4.0 + f * (4.0 - 3.0 * pow(cos(alpha),2.0)));
	z = cos(dm) + C * cos(sigma) * (-1 + 2.0 * pow(cos(dm),2.0) );
	omega = lamda - (1 - C) * f * sin(alpha) * (sigma + C * sin(sigma) * z);

	*lat2=(atan2(x , y))/pai;
	*lon2=(lon1 + omega)/pai;

}



main (void)
{
	double lon1,lon2,lat1,lat2,dirc,dist;

	lat1=35.0; lon1=135.0;
	lat2=36.0; lon2=136.0;

	printf("== ȈՕʌvZ ==\n");
	printf("n_1(ܓxF%10.6fx@oxF%10.6f)  n_2(ܓxF%10.6fx@oxF%10.6f)\n",lat1,lon1,lat2,lon2);
	Direction ( lon1, lat1, lon2, lat2, &dirc, &dist);
	printf("n_1猩n_2̐^k̕=%12.8f(xC{΁|) =%6.2f(m) \n",dirc,dist);
	vincenty(lat1, lon1, dirc, dist, &lat2, &lon2);
	printf("n_1%12.8fxC%6.2fm̒n_2 lat2=%10.6f lon2=%10.6f \n\n",dirc,dist,lat2,lon2);


	lat1=35.0; lon1=135.0;
	lat2=36.0; lon2=136.0;

	printf("== xʌvZ ==\n");
	printf("n_1(ܓxF%10.6fx@oxF%10.6f)  n_2(ܓxF%10.6fx@oxF%10.6f)\n",lat1,lon1,lat2,lon2);
	VincentyInverse( lon1, lat1, lon2, lat2, &dirc, &dist);
	printf("n_1猩n_2̐^k̕=%12.8f(xC{΁|) =%6.2f(m) \n",dirc,dist);
	vincenty(lat1, lon1, dirc, dist, &lat2, &lon2);
	printf("n_1%12.8fxC%6.2fm̒n_2 lat2=%10.6f lon2=%10.6f \n\n",dirc,dist,lat2,lon2);

}


/**** s *******

== ȈՕʌvZ ==
n_1(ܓxF 35.000000x@oxF135.000000)  n_2(ܓxF 36.000000x@oxF136.000000)
n_1猩n_2̐^k̕=-39.27465328(xC{΁|) =143323.66(m)
n_1-39.27465328xC143323.66m̒n_2 lat2= 35.995848 lon2=136.006188

== xʌvZ ==
n_1(ܓxF 35.000000x@oxF135.000000)  n_2(ܓxF 36.000000x@oxF136.000000)
n_1猩n_2̐^k̕=-38.98534585(xC{΁|) =143321.58(m)
n_1-38.98534585xC143321.58m̒n_2 lat2= 36.000000 lon2=136.000000

***********************/